#version 430 core

layout (location = 0) in vec4 in_position;
layout (location = 1) in vec4 in_color;

uniform float time;
uniform mat4 projection_matrix;

flat out vec4 star_color;

void main(void){
    vec4 vertex = in_position;

    vertex.z += time;
    vertex.z = fract(vertex.z);

    float size = (20.0 * vertex.z * vertex.z);

    star_color = smoothstep(1.0, 7.0, size) * in_color;

    vertex.z = (999.9 * vertex.z) - 1000.0;
    gl_Position = projection_matrix * vertex;
    gl_PointSize = size;
}
