#include <iostream>
using namespace std;

#include "projectionprogram.h"

void ProjectionProgram::Initialize(const char *vertex_shader_file, const char *fragment_shader_file){

    BaseProgram::Initialize(vertex_shader_file, fragment_shader_file);
    projection_matrix_location_ = GetUniformLocationOrDie("projection_matrix");
}

GLint ProjectionProgram::GetUniformLocationOrDie(const char* var_name){
    GLint location=-1;
    location = glGetUniformLocation(program_, var_name);
    if (location < 0){
        cerr << "ERROR: cannot find uniform location " << var_name << endl;
        exit( EXIT_FAILURE );
    }
    return location;
}

void ProjectionProgram::SetProjectionMatrix(const Mat4 & matrix) const{
    glUniformMatrix4fv(projection_matrix_location_, 1, GL_FALSE, matrix);
}
