#ifndef WINDOW_H
#define WINDOW_H

#include "stars.h"
#include "texture.h"
#include "matma.h"
#include "timetextureprojectionprogram.h"

class Window{
 public:
    Window(const char*, int, int);
    void Initialize(int argc, char* argv[], int major_gl_version, int minor_gl_version);
    void Resize(int new_width, int new_height);
    void Render(void);
    void KeyPressed(unsigned char key, int x_coord, int y_coord);
 private:
    int width_;
    int height_;
    const char* title_;

    Stars stars_;

    Texture star_texture_;

    TimeTextureProjectionProgram program_;

    Mat4 projection_matrix_;

    void InitGlutOrDie(int argc, char* argv[], int major_gl_version, int minor_gl_version);
    void InitGlewOrDie();
    void InitModels();
    void InitTextures();
    void InitPrograms();

    void SetProjectionMatrix();

};


#endif // WINDOW_H

