#ifndef TORUS_H
#define TORUS_H

#include "materialmodel.h"
#include "animatedmodel.h"
#include "lightablemodel.h"
#include "movablemodel.h"
#include "indexmodel.h"
#include "texturemodel.h"
#include "matma.h"
#include "vertices.h"
#include "lightprogram.h"

class Torus:
        public IndexModel,
        public AnimatedModel,
        public LightableModel,
        public MovableModel,
        public TextureModel,
        public MaterialModel{
public:
    void Initialize(GLuint n, GLuint m, GLfloat R, GLfloat r);
    void Move(GLfloat delta_t);
    void Draw(const LightProgram & program) const;
private:
    GLuint n_; // mesh parameter
    GLuint m_; // mesh parameter
    GLfloat R; //big radius
    GLfloat r; //small radius
};

#endif // TORUS_H
